<?php
namespace App\Controller\Admin;
use App\Controller\Admin\Component\ImgComponent;

use App\Controller\Admin\AppController;
use Cake\Event\Event;
use Cake\ORM\TableRegistry;
use Cake\Core\Configure;
use Cake\I18n\Time;
use Cake\View\Helper\TimeHelper;
use Cake\Datasource\ConnectionManager;
/******************************************************************************
*File Name:	 Controller
*Creation Date: [11-02-2016]
*Modification Date: [11-02-2016]
*Author: [Raushan Suri]
*Author: [Modified By Raushan Suri]
*Description: [This controller consist of function related to Department.]
******************************************************************************/
class DailyunchangingsController extends AppController
{

    public function beforeFilter(Event $event)
    {
        parent::beforeFilter($event);
        $this->Auth->allow(['showprofile']);
    }
    
    /********************************************************************************
	Function Name: index
	*Type: Public function used as action of the controller
	*Input: No input
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to view all member list and search.
	*********************************************************************************/
    public function index($id=null)
    {
        $layoutTitle = 'The 24X7 GOD :: Manage Dailyunchanging';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');
        $limit = 30;//Configure::read('App.adminPageLimit');
        
        $this->paginate = [
            'limit' => $limit,
            'order' => [
                'Dailyunchangings.created' => 'DESC'
            ],
			'contain' => ['Categories'],
        ];        
        $keyword = $this->request->query('keyword');
		$condition = [];
        if($keyword != ''){
			$condition = [
				'OR' => [
					["Dailyunchangings.title LIKE '%".$keyword."%'"],
					["Dailyunchangings.content LIKE '%".$keyword."%'"],
					["Categories.name LIKE'%".$keyword."%'"],
				]				
			];
		}        
        $query = $this->Dailyunchangings->find('all')->where($condition);       
        $dailyunchangings = $this->paginate($query);
        $dailyunchangings = $dailyunchangings->toArray();
		//pr($dailyunchangings);die;
        $this->set(compact('dailyunchangings', 'limit'));
    }

      
    /********************************************************************************
	Function Name: add
	*Type: Public function used as action of the controller
	*Input: No input
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to add hours.
	*********************************************************************************/
    public function add()
    {
        $layoutTitle = 'The 24X7 GOD ::  Add New Dailyunchanging';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');
		$this->loadModel('Categories');
		$categoryList = $this->Categories->find('list', ['keyField' => 'id', 'valueField' => ['name']])
						->where(['Categories.status'=>1])
                        ->order(['Categories.name'=>'ASC'])->toArray(); 
//		$this->loadModel('Users');
//		$userList = $this->Users->find('list', ['keyField' => 'id', 'valueField' => ['fullName']])
//						->where(['Users.status'=>1])
//                        ->order(['Users.fullName'=>'ASC'])->toArray();
						
        $dailyunchangings = $this->Dailyunchangings->newEntity();        
       
        if ($this->request->is('post')) {
            
			$userImage = @$this->request->data['image'];	
			unset($this->request->data['image']);			
			if(!empty($userImage['name'])){
				$filename = time() .'_'. $userImage['name'];
				$this->request->data['image'] = $filename;
			}
			
			$dailyunchangings = $this->Dailyunchangings->patchEntity($dailyunchangings, $this->request->data, ['validate' => 'customer']);            
			$dailyunchangings['created'] = date('Y-m-d H:i:s');
			$dailyunchangings['publishDate'] = $this->request->data['publishDate'];
			//$path = WWW_ROOT . 'img/uploads/feature/original/';
			if ($this->Dailyunchangings->save($dailyunchangings)) {
				if(!empty($userImage) && $userImage['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/dailyunchange/';	                    
					move_uploaded_file($userImage['tmp_name'], $path.$filename);
					@chmod($path.$filename, 0777);
				}
				$this->Flash->success(__('Dailyunchanging added successfully.'));
				return $this->redirect(['action' => 'index']);	
			}else{
				//pr($users);die;
				$this->Flash->error(__('Unable to add new event, Please try again later.'));
			}
		}
        $this->set(compact('dailyunchangings','categoryList', 'userList'));
    }
    
    
    
    
    /********************************************************************************
	Function Name: edit
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to edit hours.
	*********************************************************************************/
    public function edit($id)
    {
        $layoutTitle = 'The 24X7 GOD :: Edit Dailyunchanging';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');
        
		$this->loadModel('Categories');
		$categoryList = $this->Categories->find('list', ['keyField' => 'id', 'valueField' => ['name']])
						->where(['Categories.status'=>1])
                        ->order(['Categories.name'=>'ASC'])->toArray();
//		
//		$this->loadModel('Users');
//		$userList = $this->Users->find('list', ['keyField' => 'id', 'valueField' => ['fullName']])
//						->where(['Users.status'=>1])
//                        ->order(['Users.fullName'=>'ASC'])->toArray();

        $dailyunchangings = $this->Dailyunchangings->find()->where(['Dailyunchangings.id' => $id])->first();//fields name in contain[] with coma
        if ($this->request->is(['patch', 'post', 'put'])) {
			
			$userImage = $this->request->data['image'];	
			unset($this->request->data['image']);
			
			$old_data = $this->Dailyunchangings->get($id);            			
			if(!empty($userImage['name'])){
				$filename = time() .'_'. $userImage['name'];
				$categories['image'] = $filename;
				$this->request->data['image'] = $filename;
			}
			$dailyunchangings = $this->Dailyunchangings->patchEntity($dailyunchangings, $this->request->data, ['validate' => 'customer']);
			$dailyunchangings['publishDate'] = $this->request->data['publishDate'];
			
			$path = WWW_ROOT . 'img/uploads/feature/original/';
			if ($this->Dailyunchangings->save($dailyunchangings)) {
				if (!empty($userImage) && $userImage['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/dailyunchange/';	
					@unlink(WWW_ROOT . 'img/uploads/dailyunchange/'.$old_data->image);
					move_uploaded_file($userImage['tmp_name'], $path.$filename);
					@chmod($path.$filename, 0777);
					
				}
				$this->Flash->success(__('The event updated successfully.'));
                return $this->redirect(['action' => 'index']);
			} else {
				
				$this->Flash->error(__('Dailyunchanging information could not be saved. Please try again later.'));
			}
        }
        $this->set(compact('dailyunchangings', 'categoryList', 'userList'));
    }
    
    
    /********************************************************************************
	Function Name: delete
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to delete hours permanently.
	*********************************************************************************/
    public function delete($id = null)
    {
        $users = $this->Dailyunchangings->get($id);
        if ($this->Dailyunchangings->delete($users)) {
            $this->Flash->success(__('Dailyunchanging has been deleted.'));
        } else {
            $this->Flash->error(__('Dailyunchanging could not be deleted. Please, try again.'));
        }
        return $this->redirect(['controller' => 'Dailyunchangings', 'action' => 'index']);
    }
    
    
    /********************************************************************************
	Function Name: status
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to update hours status.
	*********************************************************************************/
    public function status($id){
		$users = $this->Dailyunchangings->get($id);
		$status = '1';
		$msg = 'activated';
		if($users->status == '1'){
			$status = '0';
			$msg = 'deactivated';
		}
		
		$articles = TableRegistry::get('Dailyunchangings');
		$query = $articles->query();
		$query->update()
			->set(['status' => $status])
			->where(['id' => $id])
			->execute();
		$this->Flash->success(__('Dailyunchanging has been '.$msg.' successfully.'));
		return $this->redirect(['controller' => 'Dailyunchangings', 'action' => 'index']);
	}
    
    
    /********************************************************************************
	Function Name: details
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to view hours information.
	*********************************************************************************/
    public function details($id){
        $layoutTitle = 'The 24X7 GOD ::  Member Details';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');        
		$users = $this->Dailyunchangings->find()->where(['Dailyunchangings.id' => $id])->first();
        if(!empty($users)){
            $this->set(compact('users'));
        }else{
            $this->Flash->error(__('Member doesnot exist.'));
            return $this->redirect(['controller' => 'Dailyunchangings', 'action' => 'index']);
        }
	}
	
	
}