<?php
namespace App\Model\Table;

use Cake\ORM\Table;
use Cake\Validation\Validator;
use Cake\Auth\DefaultPasswordHasher;
//use Cake\ORM\RulesChecker;
 
class EventsTable extends Table
{
    public function initialize(array $config)
    {
        
		$this->belongsTo('Users', [
            'className' => 'Users',
            //'bindingKey' => ['clientId'],
			'foreignKey' => ['userId']
        ]);
		$this->belongsTo('Categories', [
            'className' => 'Categories',
            //'bindingKey' => ['clientId'],
			'foreignKey' => ['categoryId']
        ]);
    }
    
    public function validationCustomer(Validator $validator)
    {
       
		$validator->notEmpty('name', 'Please enter name.');
		$validator->notEmpty('location', 'Please enter location.');
		$validator->notEmpty('eventDate', 'Please select Event Date.');
		$validator->notEmpty('eventCapacity', 'Please enter event capacity.');
		$validator->notEmpty('eventTime', 'Please enter event Time.');
		$validator->notEmpty('endTime', 'Please enter end Time.');
		$validator->notEmpty('categoryId', 'Please select category.');
		$validator->notEmpty('userId', 'Please select user.');
		$validator->notEmpty('designation', 'Please enter feature designation.');
        $validator->add('image', [      
				'image' => [                    
					'rule'=>  function($value){
						$ext = explode(".", $value);
						$extension = strtolower(end($ext));
						
						if (in_array(trim($extension), array('jpg', 'jpeg', 'png', 'gif'))) {							
							return true;
						}
						return false;
					},
					'message'=>'Please select jpg, jpeg, gif and png only.',
                ]
		])->notEmpty('image');
        return $validator;
    }
    
    
    
	
    
    
    
    
    
    
   

}
